
package DE.fub.inf.JVM.Util;


/**
 * Utility class that implements a sequence of bytes which can be read
 * via the `getByte()' method . This is simply a wrapper for the 
 * Java byte code stream to gain some more readability.
 */
public final class ByteSequence
{
  private byte[] bytes;
  private int    index=0;



  public ByteSequence(byte[] bytes) { this.bytes = bytes; }    
  public final int available()      { return bytes.length - index; }    
  public final byte getByte()       { return bytes[index++]; }    
  public final int getIndex()       { return index; }    
  public final byte readByte()      { return bytes[index]; }    
  public final void reset()         { index = 0; }    
}
